# Exercise 02/Section 01/Chapter 01 of [BL, page 18]

# Sets
set S;                  # Set of cenarios.

# Parameters
param p{S};             # Scenario probabilities.
param t1{S};            # Yield for wheat for each scenario s in S.
param t2{S};            # Yield for corn  for each scenario s in S.
param t3{S};            # Yield for beeet for each scenario s in S.

# Variables
var x1 >= 0;            # Planting area dedicated to wheat (acre).
var x2 >= 0;            # Planting area dedicated to corn  (acre).
var x3 >= 0;            # Planting area dedicated to beet  (acre).
var y1{S} >= 0;         # Quantity of wheat purchased for each scenario s in S (T).
var w1{S} >= 0;         # Quantity of wheat sold      for each scenario s in S (T).
var y2{S} >= 0;         # Quantity of corn  purchased for each scenario s in S (T).
var w2{S} >= 0;         # Quantity of corn sold       for each scenario s in S (T).
var w3{S} >= 0;         # Quantity of sugar sold with favorable price
                        # for each scenario s in S (T).
var w4{S} >= 0;         # Quantity of sugar sold with unfavorable price
                        # for each scenario s in S (T).

# Objective function
minimize loss: 
   150*x1 + 230*x2 + 260*x3
   - p[1]*( 0.9*(170*w1[1] - 238*y1[1] + 150*w2[1] - 210*y2[1]) + 36*w3[1] +  10*w4[1])
   - p[2]*( 1.0*(170*w1[2] - 238*y1[2] + 150*w2[2] - 210*y2[2]) + 36*w3[2] +  10*w4[2])    
   - p[3]*( 1.1*(170*w1[3] - 238*y1[3] + 150*w2[3] - 210*y2[3]) + 36*w3[3] +  10*w4[3]);

# Constraints
subject to land_area:                x1 + x2 + x3 <= 500;
subject to wheat_for_cattle{s in S}: t1[s]*x1 + y1[s] - w1[s] >= 200;
subject to corn_for_cattle{s in S}:  t2[s]*x2 + y2[s] - w2[s] >= 240;
subject to sugar_production{s in S}: w3[s] + w4[s] <= t3[s]*x3;
subject to sugar_quota{s in S}:      w3[s] <= 6000;


