# Exercise 03/Section 01/Chapter 01 of [BL, page 18]

# Sets
set S;                  # Set of cenarios.
set F;                  # Set of fields.

# Parameters
param p{S};             # Scenario probabilities.
param t1{S};            # Yield for wheat for each scenario s in S.
param t2{S};            # Yield for corn  for each scenario s in S.
param t3{S};            # Yield for beeet for each scenario s in S.
param a{F};             # Area of each field f in F.

# Variables
var x1{F} binary;       # Planting area dedicated to wheat (acre).
var x2{F} binary;       # Planting area dedicated to corn  (acre).
var x3{F} binary;       # Planting area dedicated to beet  (acre).
var y1{S} >= 0;         # Quantity of wheat purchased for each scenario s in S (T).
var w1{S} >= 0;         # Quantity of wheat sold      for each scenario s in S (T).
var y2{S} >= 0;         # Quantity of corn  purchased for each scenario s in S (T).
var w2{S} >= 0;         # Quantity of corn sold       for each scenario s in S (T).
var w3{S} >= 0;         # Quantity of sugar sold with favorable price
                        # for each scenario s in S (T).
var w4{S} >= 0;         # Quantity of sugar sold with unfavorable price
                        # for each scenario s in S (T).

# Objective function
minimize loss: 
   150*sum{f in F} a[f]*x1[f] + 230*sum{f in F} a[f]*x2[f] + 260*sum{f in F} a[f]*x3[f]
   - sum{s in S} p[s]*(170*w1[s] - 238*y1[s] + 150*w2[s] - 210*y2[s] + 36*w3[s] +  10*w4[s]);
# Constraints
subject to one_crop_for_field{f in F}: x1[f] + x2[f] + x3[f] = 1;
subject to land_area:                  sum{f in F} a[f]*x1[f] + sum{f in F} a[f]*x2[f] +
                                       sum{f in F} a[f]*x3[f] <= 500.0;
subject to wheat_for_cattle{s in S}:   t1[s]*sum{f in F} a[f]*x1[f] + y1[s] - w1[s] >= 200.0;
subject to corn_for_cattle{s in S}:    t2[s]*sum{f in F} a[f]*x2[f] + y2[s] - w2[s] >= 240.0;
subject to sugar_production{s in S}:   w3[s] + w4[s] <= t3[s]*(sum{f in F} a[f]*x3[f]);
subject to sugar_quota{s in S}:        w3[s] <= 6000.0;




