# Exercise 04/Section 01/Chapter 01 of [BL, page 18]

# Sets
set S;                  # Set of cenarios.

# Parameters
param p{S};             # Scenario probabilities.
param t1{S};            # Yield for wheat for each scenario s in S.
param t2{S};            # Yield for corn  for each scenario s in S.
param t3{S};            # Yield for beeet for each scenario s in S.

# Variables
var x1 >= 0;            # Planting area dedicated to wheat (acre).
var x2 >= 0;            # Planting area dedicated to corn  (acre).
var x3 >= 0;            # Planting area dedicated to beet  (acre).
var r1{S} integer >= 0; # Quantity of wheat purchased for each scenario s in S (100 T).
var s1{S} integer >= 0; # Quantity of wheat sold      for each scenario s in S (100 T).
var r2{S} integer >= 0; # Quantity of corn  purchased for each scenario s in S (100 T).
var s2{S} integer >= 0; # Quantity of corn sold       for each scenario s in S (100 T).
var w3{S} >= 0;         # Quantity of sugar sold with favorable price
                        # for each scenario s in S (T).
var w4{S} >= 0;         # Quantity of sugar sold with unfavorable price
                        # for each scenario s in S (T).

# Objective function
minimize loss: 
   150*x1 + 230*x2 + 260*x3
   - sum{s in S} p[s]*(170*100*r1[s] - 238*100*s1[s] + 150*100*r2[s] - 210*100*s2[s] + 
                            36*w3[s] +  10*w4[s]);

# Constraints
subject to land_area:                x1 + x2 + x3 <= 500.0;
subject to wheat_for_cattle{s in S}: t1[s]*x1 + 100*s1[s] - 100*r1[s] >= 200.0;
subject to corn_for_cattle{s in S}:  t2[s]*x2 + 100*s2[s] - 100*r2[s] >= 240.0;
subject to sugar_production{s in S}: w3[s] + w4[s] <= t3[s]*x3;
subject to sugar_quota{s in S}:      w3[s] <= 6000.0;




